import QtQuick 2.0
import Qt.labs.folderlistmodel 2.0
import QtQuick.Window 2.0

Rectangle {
    function args_contains(str) {
        if (Qt.application.arguments.indexOf(str) != -1)
            return true
        else
            return false
    }
    function args_get_images_source() {
        if (args_contains("-d"))
        {
            var i = Qt.application.arguments.indexOf("-d")
            if (Qt.application.arguments[i+1] != undefined && Qt.application.arguments[i+1][0] == '/')
                return Qt.application.arguments[i+1]
        }

        console.log("ERROR: You need to specify an absolute path to a directory to get the images from. Do it with the '-d' argument")
        Qt.quit()
    }

    height: { (args_contains("-f") ? Screen.height : 480) }
    width: { (args_contains("-f") ? Screen.width : 800) }

    ListView {
        id: listview
        anchors.fill: parent
        anchors.verticalCenter: parent.verticalCenter
        anchors.horizontalCenter: parent.horizontalCenter
        orientation: ListView.Horizontal
        keyNavigationWraps: true
        model: folderModel
        delegate: fileDelegate

        highlightMoveDuration: { (args_contains("--no-animation") ? 0 : 250) }

        Component {
            id: fileDelegate
            Image {
                width: listview.width
                height: listview.height
                fillMode: Image.PreserveAspectFit
                smooth: true
                source: folderModel.folder + "/" + fileName
            }
        }

        FolderListModel {
            id: folderModel
            showDirs: false
            showDotAndDotDot: false
            sortField: FolderListModel.Name
            nameFilters: ["*.jpg", "*.png"]
            folder: args_get_images_source()
        }
    }

    MouseArea {
        anchors.fill: parent
        onClicked: {
            listview.incrementCurrentIndex()
        }
    }
}
